import 'dart:async';
import 'package:xml/xml.dart';

import 'package:canada_post/src/models/canada_post_api_manager/canada_post_api_manager.dart';
import 'package:canada_post/src/models/canada_post_call/canada_post_call.dart';
import 'package:canada_post/src/models/mailing_scenario/mailing_scenario.dart';

class PriceCaller extends CanadaPostCall {

  PriceCaller({
    CanadaPostApiManager manager
  }) : super(
    endpoint: "ship/price",
    manager: manager, 
    method: 'POST',
    headers: {
      "Content-Type": "application/vnd.cpc.ship.rate-v3+xml",
      "Accept": "application/vnd.cpc.ship.rate-v3+xml"
    });

  Future<Map> shoot(MailingScenario mailingScenario) async {
    XmlBuilder builder = XmlBuilder();
    buildMailingScenario(builder: builder, mailingScenario: mailingScenario);

    String xml = builder.build().toXmlString();
    Map json = await super.toJson(super.call(xml));

    return json;
  }
}